diff options
author | Peter Mikus <pmikus@cisco.com> | 2019-02-26 10:24:41 +0000 |
---|---|---|
committer | Peter Mikus <pmikus@cisco.com> | 2019-02-27 19:18:43 +0000 |
commit | 2045a26e54b45a5fd7635102ceda1662d84a2047 (patch) | |
tree | 7ca5a76399a569a3b5093f394615633a31385719 /resources/libraries/bash/function/ansible.sh | |
parent | 97063f15d83378f8c5989b7116eb7a542147455f (diff) |
CSIT-1449 Ansible: Adding calibration support
- Remove obsolete bootstrap_setup.sh.
- Add calibration support into ansible.
- Inject Ansible run with calibration to every job.
Change-Id: Ib2d6cd0c04d3bce700b205bef34c3c88edb26e28
Signed-off-by: Peter Mikus <pmikus@cisco.com>
Diffstat (limited to 'resources/libraries/bash/function/ansible.sh')
-rw-r--r-- | resources/libraries/bash/function/ansible.sh | 65 |
1 files changed, 65 insertions, 0 deletions
diff --git a/resources/libraries/bash/function/ansible.sh b/resources/libraries/bash/function/ansible.sh new file mode 100644 index 0000000000..a9314b4cd2 --- /dev/null +++ b/resources/libraries/bash/function/ansible.sh @@ -0,0 +1,65 @@ +#!/usr/bin/env bash + +# Copyright (c) 2019 Cisco and/or its affiliates. +# Licensed under the Apache License, Version 2.0 (the "License"); +# you may not use this file except in compliance with the License. +# You may obtain a copy of the License at: +# +# http://www.apache.org/licenses/LICENSE-2.0 +# +# Unless required by applicable law or agreed to in writing, software +# distributed under the License is distributed on an "AS IS" BASIS, +# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. +# See the License for the specific language governing permissions and +# limitations under the License. + +set -exuo pipefail + + +function ansible_hosts () { + # Run ansible playbook on hosts in working topology file. Ansible scope is + # determined by tags passed as parameters to this function. + # + # Variable read: + # - ${WORKING_TOPOLOGY} - Reserved working topology. + # - ${TOOLS_DIR} - CSIT tools directory, where testbed-setup is located. + + set -exuo pipefail + + if ! installed sshpass; then + sudo apt-get update -y || die "apt-get update failed!" + sudo apt-get install -y sshpass || die "Install sshpass failed!" + fi + + if ! installed ansible-playbook; then + # TODO: Consider moving to requirements.txt? + pip install ansible==2.7.8 || die "Install ansible via PIP failed!" + fi + + hosts=($(fgrep host "${WORKING_TOPOLOGY}" | cut -d ":" -f 2)) || { + die "Failed to read hosts from working topology!" + } + pushd "${TOOLS_DIR}"/testbed-setup/ansible || die "Pushd failed!" + ansible-playbook \ + --vault-password-file=vault_pass \ + --extra-vars '@vault.yml' \ + --inventory inventories/lf_inventory/hosts site.yaml \ + --limit "$(echo ${hosts[@]//\"})" \ + --tags "$(echo $@)" || die "Failed to run ansible on host!" + popd || die "Popd failed!" +} + +function installed () { + + set -exuo pipefail + + # Check if the given utility is installed. Fail if not installed. + # + # Arguments: + # - ${1} - Utility to check. + # Returns: + # - 0 - If command is installed. + # - 1 - If command is not installed. + + command -v "${1}" +}
\ No newline at end of file |